"use strict";
exports.__esModule = true;
var mobx_1 = require("mobx");
var LoadingState = (function () {
    function LoadingState(defaultKey) {
        var _this = this;
        this.loadingMap = new Map();
        this.atom = mobx_1.createAtom("loadingState");
        this.on = function (key) {
            var loadingStateValue = _this.loadingMap.get(key || _this.defaultKeyName);
            _this.loadingMap.set(key || _this.defaultKeyName, loadingStateValue ? loadingStateValue + 1 : 1);
            _this.atom.reportChanged();
        };
        this.is = function (key) {
            _this.atom.reportObserved();
            return !!_this.loadingMap.get(key || _this.defaultKeyName);
        };
        this.off = function (key) {
            var loadingStateValue = _this.loadingMap.get(key || _this.defaultKeyName);
            _this.loadingMap.set(key || _this.defaultKeyName, loadingStateValue ? loadingStateValue - 1 : 0);
            _this.atom.reportChanged();
        };
        this.reset = function (key) {
            _this.loadingMap.set(key || _this.defaultKeyName, 0);
            _this.atom.reportChanged();
        };
        this.atom = mobx_1.createAtom("loadingState");
        this.defaultKeyName = defaultKey || "default";
        this.loadingMap.set(this.defaultKeyName, 0);
    }
    return LoadingState;
}());
exports.LoadingState = LoadingState;
//# sourceMappingURL=index.js.map